#include "StdAfx.h"
#include "AboutDlg.h"
#include "misc.h"

AboutDlg::AboutDlg( UINT idResource )
{
	m_idResource = idResource;
}

AboutDlg::~AboutDlg(void)
{
}

INT_PTR CALLBACK AboutDlg::DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	TCHAR		path[_MAX_PATH];
	DWORD		ver[4];
	TCHAR		verstr[100];

	switch( uMsg )
	{
	case WM_INITDIALOG:
		GetModuleFileName( NULL, path, _MAX_PATH );
		GetFileVersionDW( path, ver );
		_stprintf_s( verstr, 100, _T("%s Ver.%d.%d.%d"), szTitle, ver[0], ver[1], ver[2] );
		SetItemText( IDC_VERSTRING , verstr );
		GetCopyright( path, verstr, 100 );
		SetItemText( IDC_COPYRIGHT, verstr );
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch( wmId )
		{
		case IDOK:
		case IDCANCEL:
			EndDialog( m_hDlg, wmId );
			break;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
