#include "StdAfx.h"
#include "ManualDlg.h"
#include <commctrl.h>

ManualDlg::ManualDlg( UINT idResource )
{
	m_idResource = idResource;
}

ManualDlg::~ManualDlg(void)
{
}

INT_PTR CALLBACK ManualDlg::DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	SYSTEMTIME stt;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;
		break;

	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch( wmId )
		{
		case IDOK:
			DateTime_GetSystemtime( GetDlgItem( m_hDlg, IDC_DT_DATE ), &selTime );
			DateTime_GetSystemtime( GetDlgItem( m_hDlg, IDC_DT_TIME ), &stt );
			selTime.wHour = stt.wHour;
			selTime.wMinute = stt.wMinute;
			selTime.wSecond = stt.wSecond;
			selTime.wMilliseconds = 0;
		case IDCANCEL:
			EndDialog( m_hDlg, wmId );
			break;
		}
	}
	return 0;
}
