#ifndef _MYCHRO_ROTBLACKOUT_H_
#define _MYCHRO_ROTBLACKOUT_H_

#include "stdafx.h"
#include <windows.h>
#include <time.h>
#include <vector>
#include "PrivateProfile.h"

class RotBlackout : public PrivateProfile
{
public:
	RotBlackout();
	~RotBlackout();
	BOOL Load( TCHAR *filename = NULL );
	BOOL IsIn( SYSTEMTIME *endtime = NULL );

protected:
	typedef struct _HOURMIN {
		int hour;
		int minute;
	} HOURMIN;
	typedef struct _BLACKOUT_ELEMENT {
		int idx;
		HOURMIN start;
		HOURMIN end;
	} BLACKOUT_ELEMENT;
	std::vector<BLACKOUT_ELEMENT> table;
	ULONGLONG day_start;
	int cycle;
	int total;

	int CalcSec( HOURMIN hm );
};

#endif//_MYCHRO_ROTBLACKOUT_H_
