// TaskTray.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "TaskTray.h"
#include <mstask.h>
#include <time.h>
#include "Setting.h"
#include "SettingDlg.h"
#include "ManualDlg.h"
#include "RotBlackout.h"
#include "misc.h"
#include <PowrProf.h>
#include "AboutDlg.h"

typedef BOOL(__stdcall *CHANGEWINDOWMESSAGEFILTER)(UINT message, DWORD dwFlag);

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX
HWND g_hWnd;
static UINT g_msgTaskBarRestart;
UINT_PTR g_timer;
Setting setting;
RotBlackout blackSch;
BYTE ACStatus = 1;
AboutDlg *aboutDlg = NULL;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

#define ReleaseCom(x) if(x){x->Release();x=NULL;}

int APIENTRY _tWinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPTSTR    lpCmdLine,
					 int	   nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	OSVERSIONINFO osver;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	g_msgTaskBarRestart = RegisterWindowMessage( _T("TaskbarCreated") );
	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx( &osver );
	if ( osver.dwMajorVersion >= 6 ) {
		HMODULE user32 = LoadLibrary( _T("USER32.DLL") );
		if ( user32 != NULL ) {
			CHANGEWINDOWMESSAGEFILTER pChangeWindowMessageFilter = (CHANGEWINDOWMESSAGEFILTER)GetProcAddress(user32, "ChangeWindowMessageFilter");
			if ( pChangeWindowMessageFilter != NULL ) {
				pChangeWindowMessageFilter( g_msgTaskBarRestart, 1 );
			}
		}
	}

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (int) msg.wParam;
}



//
//	֐: MyRegisterClass()
//
//	ړI: EBhE NXo^܂B
//
//	Rg:
//
//	  ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//	  Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//	  AvP[VA֘Atꂽ
//	  `̏ACR擾ł悤ɂɂ́A
//	  ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON_ON));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_TASKTRAY);
	wcex.lpszClassName	= szTitle;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

//
//	 ֐: InitInstance(HINSTANCE, int)
//
//	 ړI: CX^X nhۑāAC EBhE쐬܂B
//
//	 Rg:
//
//		  ̊֐ŁAO[oϐŃCX^X nhۑA
//		  C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;

	hInst = hInstance; // O[oϐɃCX^Xi[܂B

	hWnd = CreateWindow(szTitle, szTitle, WS_POPUP,
		10, 10, 100, 100, NULL, NULL, hInstance, NULL);

	if (!hWnd) {
		return FALSE;
	}

	g_hWnd = hWnd;

	ShowWindow(hWnd, SW_HIDE);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//	֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//	ړI:  C EBhẼbZ[W܂B
//
//	WM_COMMAND	- AvP[V j[̏
//	WM_PAINT	- C EBhE̕`
//	WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	MSG msg;
	HMENU hMenu, hPopup;
	POINT pt;
	SYSTEMTIME st;
	static int count = 0;
	static BOOL inAbout = FALSE;

	switch (message)
	{
	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:

		switch (wmId)
		{
		case IDM_ABOUT:
			if ( aboutDlg ) {
				aboutDlg->SetFocus();
			}
			else {
				aboutDlg = new AboutDlg( IDD_ABOUTBOX );
				aboutDlg->DoModal(hWnd);
				delete aboutDlg;
				aboutDlg = NULL;
			}
			break;

		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;

		case IDM_SETTING:
			if ( setting.ShowDialog() ) {
				KillTimer( hWnd, g_timer );
				SetTimer( hWnd, 1, setting.interval() * 1000, NULL );
			}
			break;

		case IDM_MANUAL:
			{
				ManualDlg dlg( IDD_MANUAL );
				if ( dlg.DoModal(hWnd) == IDOK ) {
					SYSTEMTIME st;
					dlg.GetTime( &st );
					setting.CreateTask( &st );
				}
			}
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	case WM_TIMER:
		if ( GetACLineStatus() != 1 ) count++;
		else {
			count = 0;
		}

		if ( setting.offpeak() & blackSch.IsIn( &st ) ) {
			setting.CreateTask( &st );
			if ( setting.sleep() ) {
				SetSuspendState( FALSE, FALSE, FALSE );
			}
		}
		else if ( count >= setting.count() ) {
			count = 0;
			BOOL rot = blackSch.IsIn( &st );
			if ( rot && setting.planned() ) {
				setting.CreateTask( &st );
			}
			else {
				setting.GetFromNow( &st );
				setting.CreateTask( &st );
			}
			if ( setting.sleep() ) {
				SetSuspendState( FALSE, FALSE, FALSE );
			}
		}
		break;

	case WM_POWERBROADCAST:
		switch( wParam )
		{
		case PBT_APMRESUMESUSPEND:
		case PBT_APMPOWERSTATUSCHANGE:
			ACStatus = GetACLineStatus();
			SetTrayIcon( hWnd, TRAY_MODIFY, ACStatus );
		}
		break;

	case WM_CREATE:
		ACStatus = GetACLineStatus();
		SetTrayIcon( hWnd, TRAY_ADD, ACStatus );
		count = 0;
		setting.Load();
		blackSch.Load();
		g_timer = SetTimer( hWnd, 1, setting.interval() * 1000, NULL );
		break;

	case WM_TRAYICONMESSAGE:
		switch( lParam )
		{
		case WM_RBUTTONDOWN:
			SetForegroundWindow( hWnd );

			hMenu = LoadMenu( hInst, MAKEINTRESOURCE(IDC_TASKTRAY) );
			hPopup = GetSubMenu( hMenu, 0 );

			GetCursorPos( &pt );
			TrackPopupMenu( hPopup, TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, NULL, hWnd, NULL );

			if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}

			DestroyMenu( hMenu );
			return TRUE;
			break;
		}
		break;

	case WM_DESTROY:
		SetTrayIcon( hWnd, TRAY_DELETE, ACStatus );
		KillTimer( hWnd, g_timer );
		PostQuitMessage(0);
		break;

	default:
		if ( message == g_msgTaskBarRestart ) {
			SetTrayIcon( hWnd, TRAY_ADD, ACStatus );
		}
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

